-- This addon just report the time it gets for Sunders to get applyed
combatTimer = 0.0
local combat = false
local counting = false
local currDebuffs = {}

local function resetCombatTimer (inCombat, stack)
    if (stack == nil) then stack = 0 end
    if (inCombat == 1) then
        combatTimer = 0 + (stack * 1.5)
        combat = true
    else 
        combatTimer = 0
        combat = false
    end
end

local function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return index
        end
    end

    return 0
end

local function round(num, numDecimalPlaces)
	local mult = 10^(numDecimalPlaces or 0)

	return math.floor(num * mult + 0.5) / mult
end

local function tablelength(T)
    local count = 0
    for _ in pairs(T) do count = count + 1 end
    return count
end
  

--------------------------------------------------------------------------------

function Van_SC_OnLoad()
	this:RegisterEvent("PLAYER_REGEN_DISABLED")
    this:RegisterEvent("UNIT_AURA")
    this:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function Van_SC_OnEvent()
    local inInstance, instanceType = IsInInstance("player");
    if (inInstance == nil or (inInstance == true and instanceType ~= "raid")) then
        return;
    end
    

	if (event == "PLAYER_REGEN_DISABLED") then
		resetCombatTimer(1);
		counting = true;

	elseif event == "PLAYER_TARGET_CHANGED" then
		for i=1,16 do 
			local debuffTexture, _, _ = UnitDebuff("target",i); 
			currDebuffs[i] = debuffTexture;
        end
        local sunderStacks = has_value(currDebuffs, "Interface\\Icons\\Ability_Warrior_Sunder");
		if (sunderStacks == 0) then
			counting = true;
			resetCombatTimer(UnitAffectingCombat('target'));
        --elseif (sunderStacks < 3) then
         --   counting = true;
         --   resetCombatTimer(UnitAffectingCombat('target'), sunderStacks);
        else
            counting = false;
        end

    elseif event == "UNIT_AURA" then
		if (arg1 == 'target' and counting == true) then
			for i=1,16 do 
				local debuffTexture, sunderCount, _ = UnitDebuff("target",i); 
                if (debuffTexture == "Interface\\Icons\\Ability_Warrior_Sunder" and sunderCount == 5) then
                    local message;
                    if (combatTimer < 1) then 
                        message = "F*CK YEAH, LET'S GOOOO !"
                    elseif (combatTimer < 2) then
                        message = "yeah boy !"
                    elseif (combatTimer < 3) then
                        message = "Pas si mal !"
                    elseif (combatTimer < 4) then
                        message = "mh..."
                    else 
                        local rand = math.random(1,10);
                        if (rand == 1) then message = "bougez vous les wars !!"
                        elseif (rand == 2) then message = "c'est pas du joli..."
                        elseif (rand == 3) then message = "DAMN C'EST MOCHE :("
                        elseif (rand == 4) then message = "appuyez sur vos touches..."
                        elseif (rand == 5) then message = "MA GRAND MERE SUNDER PLUS VITE QUE CA !!!"
                        elseif (rand == 6) then message = "on va donner le froid dévorant aux rogues si ça continue !"
                        elseif (rand == 7) then message = "je suis très déçu par votre attitude."
                        elseif (rand == 8) then message = "j'ai même pas envie de commenter !"
                        elseif (rand == 9) then message = ":( :( :( :( :( :( :("
                        elseif (rand == 10) then 
                            local names = {};
                            for j=1,40 do
                                local name, _, _, _, _, class = GetRaidRosterInfo(j);
                                if (class == "WARRIOR") then table.insert(names, name) end;
                            end
                            message = "c'est la honte, je propose qu'on offre "..names[math.random(1, tablelength(names))].." en sacrifice !"
                        end
                        
                    end
                    
					SendChatMessage("Sunder x5 en "..round(combatTimer, 2).." sec, "..message);
					counting = false;
				end
			end
        end
	end
end

DO_RECRUT = false;
RECRUT_MSG1 = "Geek or Die recrute pour continuer de farm Kel'Thuzad !";
RECRUT_MSG2 = "Rush Naxx, Objectif 15/15 toutes les semaines !";
RECRUT_MSG3 = "Whispez n'importe quel membre pour plus d'infos.";
RECRUT_MSG4 = "( Mais pas moi svp j'suis au courant de rien )";

function Van_SC_OnUpdate(delta)
	if DO_RECRUT then
		if not (NEXT_ANN) then 
			NEXT_ANN = GetTime() + math.random(1200, 2700); 
			local chanIndex = GetChannelName("world");
			print(NEXT_ANN);
			--SendChatMessage(RECRUT_MSG1, "CHANNEL", nil, chanIndex);
			--SendChatMessage(RECRUT_MSG2, "CHANNEL", nil, chanIndex);
			--SendChatMessage(RECRUT_MSG3, "CHANNEL", nil, chanIndex);
			--SendChatMessage(RECRUT_MSG4, "CHANNEL", nil, chanIndex);
		elseif (NEXT_ANN < GetTime()) then
			NEXT_ANN = GetTime() + math.random(1200, 2700); 
			local chanIndex = GetChannelName("world");
			print("ENVOI")
			print(NEXT_ANN)
			--SendChatMessage(RECRUT_MSG1, "CHANNEL", nil, chanIndex);
			--SendChatMessage(RECRUT_MSG2, "CHANNEL", nil, chanIndex);
			--SendChatMessage(RECRUT_MSG3, "CHANNEL", nil, chanIndex);
			--SendChatMessage(RECRUT_MSG4, "CHANNEL", nil, chanIndex);
		end
	end

    if combat == true then
        combatTimer = combatTimer + delta
        if combatTimer < 0 then
            combatTimer = 0
		end
	end
end